/* Kleines Blink Programm mit Timer 0
	Takt 4 MHz
	Mega 8
	LED an PORTB.0
	
	LED sollte ungefhr alle 980 ms an und ausgehen.       */

#include <avr/io.h>
#include<avr/interrupt.h>		
#include<avr/signal.h>

#define toggle_led    PORTB ^= 0x01;		//Toggle LED   mit  ^=   bitweises EXOR

//Definition der globale Variablen++++++++++++++++++++++++++++++++++++++++++++++++
volatile unsigned char count;

// Timer 0 Overflow Interrupt Routine wird alle 65, 54 ms aufgerufen+++++++++++++++++++++++
SIGNAL (SIG_OVERFLOW0)
{
		count++;							//Zhler fr Overflow
		if ( count == 15)				// Zeit erreicht  15 * 65,54 ms =  983,10 ms
		{
			toggle_led;					//LED umschalten
			count = 0;						//Zhler zurck setzen
		}
}
	

// Einstellen der Hardware+++++++++++++++++++++++++++++++++++++++++++++++++++++
void init_hardware(void)
{
			DDRB = 0xff;		//PORTB auf Ausgang
			//Timer 0 einstellen Vorteiler 1024
			TCCR0 = (1<<CS00) | ( 1 << CS02); 		//Vorteiler einstellen auf 1024 
			TIMSK = (1 << TOIE0);							//Timer0 Overflow Interrupt erlauben

}

//Hauptprogramm++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void main (void)
{
			init_hardware();						//Hardware einstellen
		    sei ();  		 							//global Interrupts erlauben
			for(;;)
			{
			// Endlosschleife	
			}
}